/*
On 2008, create 2000, 2005 & 2008 compat databases

CREATE DATABASE compat80;
ALTER DATABASE  compat80 SET COMPATIBILITY_LEVEL = 80;
CREATE DATABASE compat90;
ALTER DATABASE  compat90 SET COMPATIBILITY_LEVEL = 90;
CREATE DATABASE compat100;
ALTER DATABASE  compat100 SET COMPATIBILITY_LEVEL = 100;
GO
*/

-- works on 80 & 90, fails on 100 & 120
SELECT merge = 1;
GO

-- works on 80, fails on 90 & 100
-- different error message on 2014, even in 100
SELECT TOP (1) o.name
  FROM sys.objects AS o,
       sys.columns AS c
  WHERE o.[object_id] *= c.[object_id]
  ORDER BY o.name;

-- works on 90+, fails on 80
SELECT * FROM 
  sys.dm_db_index_physical_stats(DB_ID(), NULL, NULL, NULL, NULL);

-- alternative:
DECLARE @db_id INT = DB_ID();

SELECT * 
FROM sys.dm_db_index_physical_stats(@db_id, NULL, NULL, NULL, NULL);