USE AdventureWorks2012;
SET NOCOUNT ON;
GO

-- create a simple table, and demonstrate 
-- that not all locking hints will actually
-- work as expected

CREATE TABLE dbo.blat(id INT);
INSERT dbo.blat SELECT 1;

BEGIN TRANSACTION;
SELECT TOP (1) * FROM dbo.blat UPDLOCK; 
--ORDER BY UPDLOCK.id;
SELECT * FROM sys.dm_tran_locks 
  WHERE request_session_id = @@SPID
  AND resource_type <> N'DATABASE'; 
  -- how many rows here? 0
COMMIT TRANSACTION;

BEGIN TRANSACTION;
SELECT TOP (1) * FROM dbo.blat WITH (UPDLOCK);
SELECT * FROM sys.dm_tran_locks
  WHERE request_session_id = @@SPID
  AND resource_type <> N'DATABASE'; 
  -- how many rows here? Not 0
COMMIT TRANSACTION;

DROP TABLE dbo.blat;