USE AdventureWorks2014;
SET NOCOUNT ON;
GO

-- drag columns node

-- note huge differences and also spatial results
-- this could be XML, VARBINARY(MAX), etc.

SELECT *
FROM Person.[Address] 
WHERE AddressLine1 LIKE '1% Napa%';

SELECT AddressID, AddressLine1, AddressLine2, 
  City, StateProvinceID, PostalCode
FROM Person.[Address] 
WHERE AddressLine1 LIKE '1% Napa%';

-- show in Plan Explorer (first uses scan vs. seek)



-- this does not require AdventureWorks

USE tempdb;
GO
CREATE TABLE dbo.x(a INT, b INT);
GO
INSERT dbo.x(a,b) VALUES(1,2);
GO

CREATE VIEW dbo.v_x
AS
  SELECT * FROM dbo.x;
GO

-- view will not be updated to see these changes:
EXEC sp_rename N'dbo.x.b', N'c', N'COLUMN';
ALTER TABLE dbo.x ADD b DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP;
GO

-- view still shows wrong data
SELECT * FROM dbo.v_x;
GO

EXEC sp_refreshview N'dbo.v_x';
GO

-- now view is correct
SELECT * FROM dbo.v_x;
GO

DROP VIEW dbo.v_x;
DROP TABLE dbo.x;