USE AdventureWorks2012;
SET NOCOUNT ON;
GO

-- self-join to return rank
SELECT h1.SalesOrderID, 
  rownum = 
  (
    SELECT COUNT(*) FROM Sales.SalesOrderHeader 
    WHERE OrderDate <= h1.OrderDate
    AND SalesOrderID < h1.SalesOrderID
  ) + 1
FROM Sales.SalesOrderHeader AS h1
ORDER BY h1.SalesOrderID;

SELECT SalesOrderID, 
    rownum = ROW_NUMBER() OVER (ORDER BY OrderDate, SalesOrderID)
  FROM Sales.SalesOrderHeader
  ORDER BY SalesOrderID;

-- self-join to return rank per date
SELECT h1.OrderDate, 
  rownum = 
  (
    SELECT COUNT(*) FROM Sales.SalesOrderHeader 
    WHERE OrderDate = h1.OrderDate
    AND SalesOrderID < h1.SalesOrderID
  ) + 1
FROM Sales.SalesOrderHeader AS h1
ORDER BY h1.OrderDate;

SELECT OrderDate, 
  rownum = ROW_NUMBER() OVER 
  (PARTITION BY OrderDate ORDER BY SalesOrderID)
  FROM Sales.SalesOrderHeader
  ORDER BY OrderDate;

-- PERCENTILE_CONT() for median

-- new method is actually about twice as expensive
-- even worse with a supporting index

-- CREATE INDEX t ON Sales.SalesOrderHeader(TotalDue)
-- DROP INDEX Sales.SalesOrderHeader.t

SELECT TOP (1) Median = PERCENTILE_CONT(0.5)
  WITHIN GROUP (ORDER BY TotalDue) OVER ()
FROM Sales.SalesOrderHeader ORDER BY Median;

DECLARE @c INT = (SELECT COUNT(*) FROM Sales.SalesOrderHeader);

SELECT AVG(1.0 * TotalDue)
FROM (
    SELECT TotalDue FROM Sales.SalesOrderHeader
     ORDER BY TotalDue
     OFFSET (@c - 1) / 2 ROWS
     FETCH NEXT 1 + (1 - @c % 2) ROWS ONLY
) AS x;