USE AdventureWorks2012;
SET NOCOUNT ON;
GO

-- SQL Server got smart (in some cases)

IF (SELECT COUNT(*) FROM Sales.SalesOrderHeader WHERE TotalDue > 10000) > 0
  PRINT 1;
IF (SELECT COUNT(*) FROM Sales.SalesOrderHeader WHERE TotalDue > 10000) >= 1
  PRINT 1;
IF (SELECT COUNT(*) FROM Sales.SalesOrderHeader WHERE TotalDue > 10000) <> 0
  PRINT 1;
IF (SELECT COUNT(*) FROM Sales.SalesOrderHeader WHERE TotalDue > 10000) IS NOT NULL
  PRINT 1;
IF EXISTS (SELECT 1 FROM Sales.SalesOrderHeader WHERE TotalDue > 10000)
  PRINT 1;


-- DMVs are much less expensive place for total count

SELECT COUNT(*) FROM Sales.SalesOrderHeader;

SELECT SUM(rows) FROM sys.partitions
  WHERE [object_id] = OBJECT_ID(N'Sales.SalesOrderHeader')
    AND index_id IN (0,1);


-- COUNT(*) OVER()

SELECT CustomerID, OrderDate, 
  (SELECT COUNT(*) FROM Sales.SalesOrderHeader WHERE CustomerID = h.CustomerID),
  (SELECT COUNT(*) FROM Sales.SalesOrderHeader WHERE CustomerID IN (11000, 29792))
FROM Sales.SalesOrderHeader AS h
  WHERE CustomerID IN (11000, 29792)
GROUP BY CustomerID, OrderDate;

SELECT CustomerID, OrderDate, COUNT(*)
  FROM Sales.SalesOrderHeader
  WHERE CustomerID IN (11000, 29792)
  GROUP BY GROUPING SETS((), (CustomerID), (CustomerID, OrderDate));

SELECT CustomerID, OrderDate, 
  COUNT(*) OVER(PARTITION BY CustomerID),
  COUNT(*) OVER()
FROM Sales.SalesOrderHeader
  WHERE CustomerID IN (11000, 29792);
