USE AdventureWorks2012;
SET NOCOUNT ON;
GO

CREATE TABLE #mixed_data(a VARCHAR(32));

INSERT #mixed_data VALUES('foo'),('5000'),('99'),('zebra');

SELECT a FROM #mixed_data
  WHERE a < 100
  AND a NOT LIKE '%[^0-9]%'

SELECT a FROM #mixed_data
  WHERE a NOT LIKE '%[^0-9]%'
  AND a < 100;

;WITH numbers_only AS
(
  SELECT a FROM #mixed_data
  WHERE a NOT LIKE '%[^0-9]%'
)
SELECT a
FROM numbers_only
WHERE a < 100;

;WITH numbers_only AS
(
  SELECT a = CASE WHEN a NOT LIKE '%[^0-9]%' THEN a END
  FROM #mixed_data
  WHERE a NOT LIKE '%[^0-9]%'
)
SELECT a
FROM numbers_only
WHERE a < 100;

DROP TABLE #mixed_data;

-- also, don't rely on ISNUMERIC():
;WITH x AS (SELECT x = '.' UNION ALL SELECT CHAR(9) UNION ALL SELECT ',')
SELECT x, [isnumeric] = ISNUMERIC(x) FROM x;

-- Exception; aggregate may be evaluated first:
DECLARE @i INT = 1;
SELECT CASE WHEN @i = 1 THEN 1 ELSE MIN(1/0) END;