-- CTE Examples
-- Erik Darling, read https://www.brentozar.com/archive/2015/04/ctes-inline-views-and-what-they-do/

USE AdventureWorks2014;
GO

-- Check execution plans
WITH c1 AS (
SELECT [sp].[BusinessEntityID]
     , [sp].[TerritoryID]
     , [sp].[CommissionPct]
     , [sp].[SalesYTD]
FROM [Sales].[SalesPerson] AS [sp]
WHERE [sp].[TerritoryID] = 6
)
SELECT [c1].[BusinessEntityID]
, [c1].[TerritoryID]
, [c1].[CommissionPct]
, [c1].[SalesYTD]
FROM [c1] AS [c1]
WHERE [c1].[BusinessEntityID] = 278;

-- lets pretend some additional request requires us to locate additional 
--   Business Entities in the same territory. No problemo.
WITH c1 AS (
SELECT [SP].[BusinessEntityID]
     , [SP].[TerritoryID]
     , [SP].[CommissionPct]
     , [SP].[SalesYTD]
FROM [Sales].[SalesPerson] AS [SP]
WHERE [SP].[TerritoryID] = 6
)
SELECT [sp].[BusinessEntityID]
     , [sp].[TerritoryID]
     , [sp].[CommissionPct]
     , [sp].[SalesYTD]
     , [c1].[BusinessEntityID]
     , [c1].[TerritoryID]
     , [c1].[CommissionPct]
     , [c1].[SalesYTD]
FROM [Sales].[SalesPerson] AS [sp]
JOIN [c1] AS [c1]
	ON [c1].[TerritoryID] = [sp].[TerritoryID]
WHERE [sp].[BusinessEntityID] = 278
	AND [c1].[BusinessEntityID] <> [sp].[BusinessEntityID];

-- Now, add another
WITH c1 AS (
SELECT [SP].[BusinessEntityID]
     , [SP].[TerritoryID]
     , [SP].[CommissionPct]
     , [SP].[SalesYTD]
FROM [Sales].[SalesPerson] AS [SP]
WHERE [SP].[TerritoryID] = 6
)
SELECT [sp].[BusinessEntityID]
     , [sp].[TerritoryID]
     , [sp].[CommissionPct]
     , [sp].[SalesYTD]
     , [c1].[BusinessEntityID]
     , [c1].[TerritoryID]
     , [c1].[CommissionPct]
     , [c1].[SalesYTD]
FROM [c1] AS [c1]
JOIN [Sales].[SalesPerson] AS [sp]
	ON [c1].[TerritoryID] = [sp].[TerritoryID]
JOIN [c1] AS [c2]
	ON [c2].[BusinessEntityID] = [c1].[BusinessEntityID]
WHERE [sp].[BusinessEntityID] = 278
	AND [c1].[BusinessEntityID] <> [sp].[BusinessEntityID];
