SELECT *
FROM sys.dm_os_performance_counters
WHERE counter_name LIKE '%compil%'
  AND object_name = 'SQLServer:SQL Statistics';

  -- K.Kline, 01/03/2012, a procedure to generate recompiles
  --    and cause excessive resource consumption. 
  
SET NOCOUNT ON

--IF OBJECT_ID ('#recomps', 'U') IS NOT NULL 
--    DROP TABLE #recomps 
 
CREATE TABLE #recomps 
( 
   col_a   INT NOT NULL PRIMARY KEY IDENTITY(1,1), 
   col_b   VARCHAR (50) DEFAULT 'note', 
   col_c   DATETIME DEFAULT GETDATE () 
) 

CREATE TABLE #recalcs
(
   col_x   INT NOT NULL PRIMARY KEY IDENTITY, 
   col_y   MONEY DEFAULT 0.00 
)
 
DECLARE @nbr_of_recompiles  INT 
DECLARE @sqldml   VARCHAR (500) 
DECLARE @sqlddl   VARCHAR (500) 
 
IF @nbr_of_recompiles IS NULL 
   SELECT @nbr_of_recompiles = 256
   -- In the SE Demo Environment, 256 generates very high recomps using hardware
 
-- Set up for the loop 
DECLARE @counter1   INT 
DECLARE @counter2   INT 
DECLARE @holder1    VARCHAR(4)
 
SELECT @counter1 = 0 
SELECT @counter2 = 0   -- Currently a spare counter, not used
 
-- Create the loop to generate the requested number of recompiles.
-- Temp tables cause more recomps than permanent tables, per
--   Msft KB http://bit.ly/pff788 
WHILE @counter1 < @nbr_of_recompiles 
BEGIN 
   -- loop counter 
   SELECT @counter1 = (@counter1 + 1) 
   SELECT @holder1  = CAST (@counter1 AS VARCHAR(4))
   
	EXEC ('INSERT INTO #recomps DEFAULT VALUES')

	EXEC ('INSERT INTO #recalcs DEFAULT VALUES')
   
	EXEC ('ALTER TABLE #recomps ADD col1 INT NULL')
	
	EXEC ('UPDATE #recomps SET col1 = 9999')
    
	EXEC ('ALTER TABLE #recalcs ADD col1 INT NULL')
   
	EXEC ('UPDATE #recalcs SET col1 = 123 ') 

	EXEC ('UPDATE #recomps SET col1 = 123 ')
 
	EXEC ('ALTER TABLE #recomps ALTER COLUMN col1 SMALLINT NULL')

	EXEC ('UPDATE #recalcs SET col1 = 123')
 
	EXEC ('ALTER TABLE #recalcs ALTER COLUMN col1 SMALLINT NULL')
   
	EXEC ('UPDATE #recomps SET col1 = 567')
		   
	EXEC ('UPDATE #recalcs SET col1 = 567')
   
	EXEC ('UPDATE #recomps SET col_b = ''cntr_test'' WHERE col_a > 100')
		 
	EXEC ('ALTER TABLE #recomps DROP COLUMN col1')
	 
	EXEC ('UPDATE #recalcs SET col_y = 19.99 WHERE col_x > 100')

	EXEC ('ALTER TABLE #recalcs DROP COLUMN col1')
   
END

GO

SELECT * FROM #recomps ORDER BY 1
SELECT * FROM #recalcs ORDER BY 1
GO

DROP TABLE #recomps
DROP TABLE #recalcs
GO

SELECT *
FROM sys.dm_os_performance_counters
WHERE counter_name LIKE '%compil%'
  AND object_name = 'SQLServer:SQL Statistics';

